'Gewitterwarner 2 mit reduzierter Taktfrequenz, Levelbegrenzung, AGC-Dynamisierung
'und Powerdown 4 : 1


'MB 10.8.2016 Blitzwarner2T13_2d: zustzlich zu Blitzwarner2T13_2c vom 18.08.2013, 12:06:
'  *) serielle Ausgabe der Daten am Pin der roten LED PB2, hier einen BSS138 fr UART opendrain
'     Daten: {ID [8 bits] } {HI(Level) [8 bits] } { LO(Level) [8 bits]} { pwm [8 bits] }
'     Aus Level und pwm knnte man eventuell den Batteriezustand grob bestimmen
'  *) zustzlich gelbe LED zur roten LED bei Begrenzung
'  *) Alle 9h wird neu initialisiert
'  *) Codeoptimierungen um Speicher einzusparen: ISR Nosave, Abfragen optimieren
'  -) funktioniert nicht, fllt immer in Reset
'
'
'MB 2.3.2017
'  *) Bugfixings: Fusebytes fr WDT und BOR, IF/THEN unerkannter Syntaxfehler mit mehreren Kommandos in einer Zeile
'  *) Codeoptimierungen um Speicher einzusparen: High(Level) statt Shift right 8, Decay als Byte statt Word
'  *) Seriellausgabe: nur ab 6min ab POR, dann alle 30s, zum POR ein/ausschaltbar
'  O) Rote LED verursacht Break am UART -> 100ms Delay nach Opencom -> funktioniert mit CH341 und Perl auf Debian
'
'  Code: 1012 bytes  (Frei: 12) -> wenn als test.bas ohne weitere Files compiliert, sind weitere 4 Bytes frei
'  RAM:    51 bytes  (Frei: 13)



' Programmieren mit avedude (Bascom-USBASP-Programmer funktioniert nicht mit der langsamen clock!)
'rem fr Tiny13 mit 128kHz RC-Osc
'rem Flash:
'avrdude -p t13 -c USBasp -B 50 -U flash:w:Blitzwarner2T13_2d.hex:i
'rem verify
'avrdude -p t13 -c USBasp -B 50 -U flash:v:Blitzwarner2T13_2d.hex:i
'
'
'Tiny 13 Fuses: setzen am besten mit xTreme Burner, Test mit ebendiesem oder
'avrdude -p t13 -c USBasp -B 50
'
'
'factory default:
'Low Fuse: 0x6A
'  SPI enable, WDT off, divide Clock by 8 ON, 1010 RC.Osc 9.6MHz
'High Fuse: 0xFF
'  Selfprog disabled, Debugwire disabled, BOD disabled, Ext.Reset enable (!!)
'Ext Fuse: 0xFF
'Lock Fuse: 0xFF
'Calibration: 5D5D5D5F
'
'
'Fuses mssen folgendermaen gesetzt werden:
'Low Fuse: 0x7B
'  SPI enable, WDT always OFF (ansonsten kein Interrupt-Modus des WDT!), divide Clock by 8 OFF, 1011 RC.Osc 128kHz, startuptime 14 CK+64ms
'High Fuse: 0xFD
'  Selfprog disabled, Debugwire disabled, BOD enable auf typ 1,8V (1,7..2V), Ext.Reset enable (!!)
'


' $PROG LB, FBL , FBH , FBX
$PROG &HFF , &H7B , &HFD , &H00                             ' generated. Take care that the chip supports all fuse bytes.


CONST ID = &B10100000                                       ' 0xA0 bzw. 160 dez
' ID als erstes serielles Byte

$regfile = "attiny13.dat"

$crystal = 128000                                           'Taktfrequenz
$hwstack = 16                                               ' fr Sprungadressen und ISR-Registersichrungen
$swstack = 10                                               ' fr bergabeparameteradressen in Unterfunktionen
$framesize = 10                                             ' fr bergabeparameter fr Unterfunktionen


Stop Ac                                                     'Analogkomparator deaktivieren -> Energie sparen (ca. 70 A)
Stop Adc                                                    ' Analog-Digital-Wandler deaktivieren -> Energie sparen (ca. 210 A)

Wdtcr = &B11110001                                          'Watchdog auf 8s einstellen, lst Interrupt und nicht Reset aus
'Config Portb = &B00011100  -> kann man sich hier sparen, da POR-Config zum Einlesen der Seriell-Funktionalitt schon passt

Config Timer0 = Pwm , Prescale = 1 , Compare A Pwm = Clear Up       'PWM B0
Start Timer0

Config Int0 = Rising                                        'INT0 B1
On Int0 Isrint0 Nosave                                      ' ACHTUNG Nosave: benutzte Register mssen hndisch gesichert werden!
Enable Int0

Dim C As Byte
Dim I As Byte
Dim J As Byte
Dim P As Byte
Dim Count As Word
Dim Level As Word
Dim Decay As Byte

Dim Portb_var As Byte
Dim Temp1 As Byte
Dim Temp2 As Byte
Dim Runtime As Byte
' Laufzeit in 128s-Einheiten ohne Gewitter (Sparversion, Word ergibt 40bytes zuviel code)
' 255 entsprechen somit ca. 9,06h


Dim Ser_out As Bit
' PORTB-Konfiguration steht nach POR auf Input ohne Pullups.
Ser_out = PINB.4                                            'Serout Konfiguration?
Config PORTb = &B00011101                                   'Port I/Os Datenrichtung setzen


Init:
Runtime = 0
Count = 0
I = 0
Portb = &B00011000                                          ' grn und orange zum Test ein
If Ser_out = 1 Then Portb.2 = 1                             ' rot ein zur Anzeige des SeriellModus
Do
  I = I + 1
  Pwm0a = I
  Enable Interrupts                                         ' Count wird in der ISR inkrementiert
  Waitms 50
  Disable Interrupts
Loop Until Count > 200                                      'Ub einstellen
Portb = &B00000000                                          ' alle LEDs wieder aus
Shift I , Right                                             'durch 2
J = I
Shift J , Right , 2
J = J + I                                                   'PWM=62,5%  (Ruhe-PWM)
Pwm0a = J
Wait 2
Level = 255




Do

 For C = 0 To 29                                            '30 s messen

  Reset Watchdog                                            ' frher als 8s !
  Count = 0
  Enable Interrupts
  Waitms 1000                                               '1 s zhlen
  Disable Interrupts
  If Count > 32 Then                                        'min 2 Impulse
    Level = Level + Count                                   'Count
    Portb.3 = 1                                             'Blitz-LED B3 grn
    Waitms 20
    Portb.3 = 0
    Waitms 20
  End If
  Decay = High(Level)                                       'Level/256; Decay ist 0 wenn Level <= 255, Level ist minimal 255 per Vorgabe
  Level = Level - Decay                                     'Level nimmt ab



  Portb_var = &B00000000                                    ' vorsetzen
  If Level < 1000 Then Pwm0a = J                            'PWM=62,5% (Ruhe-PWM)
  If Level > 2000 Then Portb_var = &B00001000               ' grn
  If Level > 3000 Then Pwm0a = I                            'PWM=50%
  If Level > 4000 Then Portb_var = &B00010000               'gelb
  If Level > 6000 Then Portb_var = &B00000100               'rot
  If Level > 7000 Then
   Portb_var = &B00010100                                   'rot und gelb
   Level = 7000                                             'und Levelbegrenzung: Achtung...
  End If

' If C = 0 AND Ser_out = 1 AND Runtime > 3 Then   ' braucht ca. 40 Bytes mehr!!
  If C = 0 Then
   If Ser_out = 1 Then
    If Runtime > 3 Then                                     ' Ausgabe alle 30s erst nach 6 Minuten nach Neustart und Init
       Open "comb.2:1200,8,n,1,INVERTED" For Output As #1   ' geht sich bei 128kHz Clock noch aus, aber Bitfehler ca. 1% im MSB
       Waitms 100                                           ' lange warten um bei rot den Break-Zustand am CH341 zu beenden (Versuch)
       Temp1 = High(Level)
       Temp2 = Low(Level)
       Print #1 , chr(ID) ; chr(Temp1) ; chr(Temp2) ; chr(Pwm0a) ;       ' ca. 32ms bei 1200bps , Printbin braucht 10 Bytes mehr!
       Close #1
    End If
   End If
  End If

  PORTB = Portb_var                                         ' und jetzt erst auf den Port ausgeben, das gibt die Mglichkeit, dass die seriellen Daten bei "rot" noch einmal vor dem Break gelesen werden knnen

 Next C


  If Decay = 0 Then                                         'Nix zu tun
   Disable Int0                                             '98 s Pause
   Stop Timer0
   Portb.0 = 0
   Enable Interrupts
   For P = 0 To 11                                          ' 12 x 8s = 96s
    Reset Watchdog
    Powerdown
   Next P
   Disable Interrupts
   Enable Int0
   Start Timer0
   Pwm0a = J
   Wait 2
   INCR Runtime
  End If


  If Runtime >= 250 Then
   If Level = 255 Then                                      ' nur wenn gerade keine Aktivitt ist alle 9h neu initialisieren
    Pwm0a = 0                                               ' wichtig fr Neuinitialisierung alle 9h
    Waitms 10000                                            ' warten bis sich die beiden 100uF Kondensatoren entladen haben, sonst falsche PWM bei Warmstart!
    Goto Init
    ' Init alle ca. 9h
   End If
  End If

Loop



Isrint0:
' Compiler ist ineffizient: es werden per default ALLE Register gesichert
' laut Disassembler werden nur folgende Register benutzt: (8 Bytes Stack fr Register + Adresse)
 PUSH R16
 PUSH R17
 PUSH R21
 PUSH R25
 push R24
 push XL
 push XH

 in R24,SREG
 push R24

 Count = Count + 32                                         'Software-Counter
 If Count >= 250 Then Count = 250


 pop R24
 !Out SREG,R24
 POP XH
 POP XL
 POP R24
 POP R25
 POP R21
 POP R17
 POP R16

Return

End